package ch.unige.solidify.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.config.SolidifyProperties;
import ch.unige.solidify.rest.Resource;
import ch.unige.solidify.service.GitInfoService;
import ch.unige.solidify.service.ModuleService;

@Controller
public class DashboardController {

  private SolidifyProperties config;
  private GitInfoService gitInfoService;
  private ModuleService<? extends Resource<?>> moduleService;

  @Autowired
  public DashboardController(SolidifyProperties config, GitInfoService gitInfoService,
          ModuleService<? extends Resource<?>> moduleService) {
    this.config = config;
    this.gitInfoService = gitInfoService;
    this.moduleService = moduleService;
  }

  @GetMapping(SolidifyConstants.URL_DASHBOARD)
  public String dashboard(Model model) {
    model.addAttribute("applicationName", this.config.getServerDisplayName());
    model.addAttribute("applicationVersion", this.gitInfoService.getBuildVersion());
    model.addAttribute("modules", this.moduleService.getModuleControllerList());
    return "dashboard";
  }
}
