package ch.unige.solidify.controller;


import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;

import ch.unige.solidify.model.Module;
import ch.unige.solidify.rest.ActionName;
import ch.unige.solidify.service.MessageService;

public abstract class ModuleController {

  @Autowired
  MessageService messageService;

  private String name;
  protected String root;
  protected List<ControllerWithHateoasHome> resourceList;

  protected ModuleController(String name) {
    this.name = name;
    root = name.toLowerCase();
    resourceList = new ArrayList<>();
  }

  public String getName() {
    return name;
  }

  public String getRoot() {
    return root;
  }

  @GetMapping
  public HttpEntity<Module> home() {
    Module mod = new Module(getName());
    mod.add(linkTo(methodOn(this.getClass()).home()).withSelfRel());
    for (ControllerWithHateoasHome r : resourceList) {
      mod.add(linkTo(methodOn(r.getClass()).home()).withRel(ActionName.RESOURCES));
    }
    return new ResponseEntity<>(mod, HttpStatus.OK);
  }

  public void addResource(ControllerWithHateoasHome r) {
    resourceList.add(r);
  }

  public List<ControllerWithHateoasHome> getRourceList() {
    return resourceList;
  }

}
