package ch.unige.solidify.service;

import java.util.Date;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Service;

@Service
@PropertySource("classpath:git.properties")
public class GitInfoService {

  @Value("${spring.application.name}")
  private String appName;

  @Value("${git.branch}")
  private String branch;

  @Value("${git.tags}")
  private String tags;

  @Value("${git.commit.id.describe}")
  private String commitIdDescribe;

  @Value("${git.commit.id.describe-short}")
  private String commitIdDescribeShort;

  @Value("${git.commit.id}")
  private String commitId;

  @Value("${git.commit.id.abbrev}")
  private String commitIdAbbrev;

  @Value("${git.build.version}")
  private String buildVersion;

  @Value("#{new java.text.SimpleDateFormat(\"yyyy-MM-dd'T'HH:mm:ssZ\").parse(\"${git.commit.time}\")}")
  private Date commitTime;

  @Value("#{new java.text.SimpleDateFormat(\"yyyy-MM-dd'T'HH:mm:ssZ\").parse(\"${git.build.time}\")}")
  private Date buildTime;

  @Value("${git.build.user.name}")
  private String buildUserName;

  @Value("${git.build.user.email}")
  private String buildUserEmail;

  @Value("${git.commit.message.full}")
  private String commitMessageFull;

  @Value("${git.commit.message.short}")
  private String commitMessageShort;

  @Value("${git.commit.user.name}")
  private String commitUserName;

  @Value("${git.commit.user.email}")
  private String commitUserEmail;

  @Value("${git.remote.origin.url}")
  private String remoteOriginUrl;

  protected String getBranch() {
    return branch;
  }

  protected String getTags() {
    return tags;
  }

  protected String getCommitIdDescribe() {
    return commitIdDescribe;
  }

  protected String getCommitIdDescribeShort() {
    return commitIdDescribeShort;
  }

  protected String getCommitId() {
    return commitId;
  }

  protected String getCommitIdAbbrev() {
    return commitIdAbbrev;
  }

  protected Date getCommitTime() {
    return commitTime;
  }

  public String getAppName() {
    return appName;
  }

  public String getBuildVersion() {
    return buildVersion;
  }

  protected Date getBuildTime() {
    return buildTime;
  }

  protected String getBuildUserName() {
    return buildUserName;
  }

  protected String getBuildUserEmail() {
    return buildUserEmail;
  }

  protected String getCommitMessageFull() {
    return commitMessageFull;
  }

  protected String getCommitMessageShort() {
    return commitMessageShort;
  }

  protected String getCommitUserName() {
    return commitUserName;
  }

  protected String getCommitUserEmail() {
    return commitUserEmail;
  }

  protected String getRemoteOriginUrl() {
    return remoteOriginUrl;
  }

}
