package ch.unige.solidify.oracle.test;

import static org.hamcrest.CoreMatchers.is;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;

import ch.unige.solidify.oracle.test.web.TestConfigApplication;

@RunWith(SpringRunner.class)
@AutoConfigureMockMvc
@SpringBootTest(classes = TestConfigApplication.class)
@WithMockUser(username = "TEST", password = "TEST")
public class ReadOnlyControllerWithOracleDbTest {

  @Autowired
  private MockMvc mockMvc;

  @Test
  public void testGetSearchWithOracleContains() throws Exception {
    mockMvc.perform(get("/oraTest/search?search=namesForSearch¢%RAOLI% WITHIN PRENOMS"))
            .andExpect(status().isOk())
            .andExpect(content().contentType("application/hal+json"))
            // .andDo(print());
            .andExpect(jsonPath("_data[0].entityId", is("514425")));
  }

  @Test
  public void testGetSearchWithOracleContainsMix() throws Exception {
    mockMvc.perform(get("/oraTest/search?search=lastname:WANG,namesForSearch¢RAOLI WITHIN PRENOMS"))
            .andExpect(status().isOk())
            .andExpect(content().contentType("application/hal+json"))
            // .andDo(print());
            .andExpect(jsonPath("_data[0].entityId", is("514425")));
  }
}
