package ch.unige.solidify.test.controller.dao;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

public class MockUserSpecification implements Specification<MockUser> {
  private static final long serialVersionUID = -3912705912816966396L;

  private final MockUser criteria;

  public MockUserSpecification(MockUser criteria) {
    this.criteria = criteria;
  }

  @Override
  public Predicate toPredicate(Root<MockUser> root, CriteriaQuery<?> criteriaQuery,
          CriteriaBuilder criteriaBuilder) {
    List<Predicate> listPredicate = new ArrayList<>();
    if (criteria.getName() != null) {
      listPredicate.add(criteriaBuilder.like(root.get("name"), "%" + criteria.getName() + "%"));
    }
    return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
  }
}
