package ch.unige.solidify.test.model;

import java.util.List;

public class OpenApiExtraDocumentationProperties {
  private String fieldName;
  private List<String> enumsValue;
  private String format;
  private String item;

  public OpenApiExtraDocumentationProperties(String fieldName) {
    this.fieldName = fieldName;
    this.format = null;
    this.item = null;
    this.enumsValue = null;
  }

  public OpenApiExtraDocumentationProperties(String fieldName, String format) {
    this(fieldName);
    this.format = format;

  }

  public OpenApiExtraDocumentationProperties(String fieldName, String format, String item) {
    this(fieldName, format);
    this.item = item;
    this.enumsValue = null;
  }

  public OpenApiExtraDocumentationProperties(String fieldName, String format, List<String> enumsValue) {
    this(fieldName, format);
    this.enumsValue = enumsValue;
  }

  public List<String> getEnumsValue() {
    return enumsValue;
  }

  public String getFormat() {
    return format;
  }

  public String getFieldName() {
    return fieldName;
  }

  public String getItem() {
    return item;
  }

}
