package ch.unige.solidify.config;

import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.stereotype.Service;

@Service
public final class SolidifyEventPublisher implements ApplicationEventPublisherAware {

  private static final SolidifyEventPublisher INSTANCE = new SolidifyEventPublisher();
  private ApplicationEventPublisher publisher;

  private SolidifyEventPublisher() {
  }

  @Override
  public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
    INSTANCE.publisher = applicationEventPublisher;
  }

  public static ApplicationEventPublisher getPublisher() {
    return INSTANCE.publisher;
  }

}
