package ch.unige.solidify.rest;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;

public interface ResourceClient<T extends Resource<T>> {

  T findOne(String resId);

  Collection<T> findAll(Pageable pageable);

  @Cacheable(CacheNames.RESOURCES)
  default T findOneWithCache(String resId) {
    return this.findOne(resId);
  }

}
