package ch.unige.solidify.rest;

import javax.persistence.AttributeOverride;
import javax.persistence.AttributeOverrides;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.EntityListeners;
import javax.persistence.MappedSuperclass;
import javax.validation.Valid;

import ch.unige.solidify.listener.CacheListener;
import ch.unige.solidify.model.ChangeInfo;

@MappedSuperclass
@EntityListeners({ CacheListener.class })
public abstract class ResourceLegacy<T> extends ResourceDiverse<T> {

  @AttributeOverrides({ @AttributeOverride(name = "when", column = @Column(name = "d_cre")),
          @AttributeOverride(name = "who", column = @Column(name = "id_cre")) })
  @Embedded
  @Valid
  protected ChangeInfo creation = new ChangeInfo();

  @AttributeOverrides({ @AttributeOverride(name = "when", column = @Column(name = "d_maj")),
          @AttributeOverride(name = "who", column = @Column(name = "id_maj")) })
  @Embedded
  @Valid
  protected ChangeInfo lastUpdate = new ChangeInfo();

  public ChangeInfo getCreation() {
    return this.creation;
  }

  public ChangeInfo getLastUpdate() {
    return this.lastUpdate;
  }

}
