package ch.unige.solidify.rest;

import java.util.Objects;

import org.springframework.hateoas.RepresentationModel;

public class Result extends RepresentationModel<Result> {

  private final String resId;
  private ActionStatus status;
  private String message;

  public enum ActionStatus {
    EXECUTED, NOT_EXECUTED, NON_APPLICABLE
  }

  public Result() {
    this.resId = null;
    this.status = ActionStatus.NON_APPLICABLE;
    this.message = null;
  }

  public Result(String id) {
    this.resId = id;
    this.status = ActionStatus.NON_APPLICABLE;
    this.message = null;
  }

  public String getResId() {
    return resId;
  }

  public ActionStatus getStatus() {
    return status;
  }

  public String getMessage() {
    return message;
  }

  public void setStatus(ActionStatus status) {
    this.status = status;
  }

  public void setMesssage(String m) {
    this.message = m;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (!(obj instanceof Result)) {
      return false;
    }
    Result result = (Result) obj;
    return super.equals(result) && Objects.equals(resId, result.getResId())
            && Objects.equals(status, result.getStatus())
            && Objects.equals(message, result.getMessage());
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), resId, status, message);
  }

}
