package ch.unige.solidify.util;

import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class StringParserTool {

  public static List<SearchCriteria> parseSearchString(String searchinput) {
    if (searchinput == null || searchinput.trim().isEmpty()) {
      return null;
    }
    String search = null;
    if (searchinput.contains("+")) {
      searchinput = searchinput.replace("+", "%2B");
    }

    try {
      search = java.net.URLDecoder.decode(searchinput, StandardCharsets.UTF_8.name());
    } catch (Exception e) {
      search = searchinput;
    }

    String delim = ",";
    String regex = "(?<!\\\\)" + Pattern.quote(delim);
    String[] searchList = search.split(regex);
    List<SearchCriteria> criterias = new ArrayList<>();
    String operationSetExper = String.join("|", SearchOperation.OPERATION_SET);
    Pattern pattern = Pattern.compile("([ic]-)??([\\w|_|.]+?)(" + operationSetExper + ")(.+?)$");
    for (String item : searchList) {
      Matcher matcher = pattern.matcher(item);
      if (matcher.find()) {
        String caseFlag = matcher.group(1) == null ? null : matcher.group(1).trim().substring(0, 1);
        SearchCriteria criteria = new SearchCriteria(caseFlag, matcher.group(2), matcher.group(3),
                matcher.group(4));
        criterias.add(criteria);
      }
    }
    return criterias;
  }
}
