package ch.unige.solidify.test.specification;

import ch.unige.solidify.test.config.MockUserJpaConfig;
import ch.unige.solidify.test.specification.dao.EntityCETMock;
import ch.unige.solidify.test.specification.dao.EntityCetMockRepository;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.Optional;

@RunWith(SpringRunner.class)
@DataJpaTest
@ContextConfiguration(classes = { MockUserJpaConfig.class })
public class ResourceCETTest {

  @Resource
  private EntityCetMockRepository entityDefaultMockRepository;

  @Before
  public void setup() {
    EntityCETMock entity = new EntityCETMock();
    entity.setEntityId("1");
    entity.setLabel("init");
    entity.setUpdatedBy("firstUser");
    entity.setCreatedBy("unitTEST");
    entityDefaultMockRepository.save(entity);
  }

  public void Test_insert_metaData() {

    Optional<EntityCETMock> entity2 = entityDefaultMockRepository.findById("1");
    Assert.assertNotNull(entity2.get().getCreationTime());
    Assert.assertNotNull(entity2.get().getUpdateTime());

  }

  @Test
  public void Test_update() {
    Optional<EntityCETMock> entity = entityDefaultMockRepository.findById("1");
    EntityCETMock entityMock = entity.get();
    entityMock.setLabel("changed");
    entityMock.setUpdatedBy("new");
    entityDefaultMockRepository.save(entityMock);
    Optional<EntityCETMock> entity2 = entityDefaultMockRepository.findById("1");
    Assert.assertEquals("changed", entity2.get().getLabel());
  }

}
