package ch.unige.solidify.test.specification.dao;

import javax.persistence.*;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.OffsetDateTime;

@Entity
public class MockUser {
  @Id
  @GeneratedValue(strategy = GenerationType.AUTO)
  private Long id;
  private String name;
  private int age;
  private Integer childNumber;
  private Long carKilos;
  private BigDecimal salary;
  private LocalDate birthday;
  private LocalDateTime marriageTime;
  private OffsetDateTime meetingTime;
  @OneToOne
  @JoinColumn(name = "info_id")
  private MockUserInfo userInfo;

  public MockUser() {
    super();
  }

  public MockUser(String name, int age) {
    this.name = name;
    this.age = age;
  }

  public MockUser(String name, int age, Integer childNumber, Long carKilos, BigDecimal salary,
          LocalDate birthday,
          LocalDateTime marriageTime, OffsetDateTime meetingTime) {
    this.name = name;
    this.age = age;
    this.childNumber = childNumber;
    this.carKilos = carKilos;
    this.salary = salary;
    this.birthday = birthday;
    this.marriageTime = marriageTime;
    this.meetingTime = meetingTime;
  }

  public LocalDateTime getMarriageTime() {
    return marriageTime;
  }

  public void setMarriageTime(LocalDateTime marriageTime) {
    this.marriageTime = marriageTime;
  }

  public OffsetDateTime getMeetingTime() {
    return meetingTime;
  }

  public void setMeetingTime(OffsetDateTime meetingTime) {
    this.meetingTime = meetingTime;
  }

  public MockUserInfo getUserInfo() {
    return userInfo;
  }

  public void setUserInfo(MockUserInfo userInfo) {
    this.userInfo = userInfo;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Long getId() {
    return id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public int getAge() {
    return age;
  }

  public void setAge(int age) {
    this.age = age;
  }

  public BigDecimal getSalary() {
    return salary;
  }

  public Integer getChildNumber() {
    return childNumber;
  }

  public void setChildNumber(Integer childNumber) {
    this.childNumber = childNumber;
  }

  public Long getCarKilos() {
    return carKilos;
  }

  public void setCarKilos(Long carKilos) {
    this.carKilos = carKilos;
  }

  public LocalDate getBirthday() {
    return birthday;
  }

  public void setBirthday(LocalDate birthday) {
    this.birthday = birthday;
  }

  public LocalDateTime getMarriageTim() {
    return marriageTime;
  }

  public void setMarriageTim(LocalDateTime marriageTim) {
    this.marriageTime = marriageTim;
  }

  public void setSalary(BigDecimal salary) {
    this.salary = salary;
  }

  @Override
  public String toString() {
    return "MockUser{" +
            "id=" + id +
            ", name='" + name + '\'' +
            ", age=" + age +
            ", childNumber=" + childNumber +
            ", carKilos=" + carKilos +
            ", salary=" + salary +
            ", birthday=" + birthday +
            ", marriageTime=" + marriageTime +
            '}';
  }
}
