package ch.unige.solidify.test.util;

import java.io.UnsupportedEncodingException;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;

import ch.unige.solidify.util.SearchCriteria;
import ch.unige.solidify.util.SearchOperation;
import ch.unige.solidify.util.StringParserTool;

public class StringParserToolTest {

  @Test
  public void testString() {
    String search = "user.lastName:<w!.*\\\\,ang%,age≥30_60,i-my_test_9.is§this@gmail.com";
    List<SearchCriteria> criterias = StringParserTool.parseSearchString(search);
    Assert.assertEquals(3, criterias.size());
    for (SearchCriteria item : criterias) {
      System.out.println(item);
    }
  }

  @Test
  public void testStringWithEsacpecharacters() throws UnsupportedEncodingException {
    String search = "statut%C2%ACA,isDomPers:true,meetingTime:2007-12-03T10:15:30+01:00";
    List<SearchCriteria> criterias = StringParserTool.parseSearchString(search);
    Assert.assertEquals(3, criterias.size());

  }

  @Test
  public void testUrlWithAllOperation() throws UnsupportedEncodingException {
    for (String operator : SearchOperation.getOperationList()) {
      String search = "meetingTime" + operator + "2007-12-03T10:15:30+01:00";
      if (SearchOperation.getOperation(operator) == SearchOperation.BETWEEN) {
        search = "marriageTime∞2003-10-03T10:15:30_2016-02-03T12:15:30";
      }
      List<SearchCriteria> criterias = StringParserTool.parseSearchString(search);
      Assert.assertEquals(1, criterias.size());
      for (SearchCriteria item : criterias) {
        System.out.println(item);
      }
    }

  }

}
