package ch.unige.solidify.util;

import java.security.MessageDigest;
import java.util.zip.CRC32;

public class CRC extends MessageDigest {

  private CRC32 crcValue;

  public CRC() {
    super("CRC32");
    crcValue = new CRC32();
  }

  @Override
  protected void engineUpdate(byte input) {
    crcValue.update(input);
  }

  @Override
  protected void engineUpdate(byte[] input, int offset, int len) {
    crcValue.update(input, offset, len);
  }

  @Override
  protected byte[] engineDigest() {
    long l = crcValue.getValue();
    byte[] bytes = new byte[4];
    bytes[0] = (byte) ((l & 0xFF000000) >> 24);
    bytes[1] = (byte) ((l & 0x00FF0000) >> 16);
    bytes[2] = (byte) ((l & 0x0000FF00) >> 8);
    bytes[3] = (byte) (l & 0x000000FF);
    return bytes;
  }

  @Override
  protected void engineReset() {
    crcValue.reset();
  }

}
