package ch.unige.solidify.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import javax.xml.bind.DatatypeConverter;

import ch.unige.solidify.exception.SolidifyRuntimeException;

public class HashTool {

  public static String hash(String token) {
    MessageDigest messageDigest;
    try {
      messageDigest = MessageDigest.getInstance("SHA-256");
    } catch (NoSuchAlgorithmException e) {
      throw new SolidifyRuntimeException("SHA-256 algorithm not available");
    }
    messageDigest.update(token.getBytes());
    return DatatypeConverter.printHexBinary(messageDigest.digest());
  }

}
