package ch.unige.solidify.util;

import java.util.concurrent.TimeUnit;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ch.unige.solidify.SolidifyConstants;

public class SolidifyTime {
  private static final Logger log = LoggerFactory.getLogger(SolidifyTime.class);

  /**
   * This constructor should not be called
   */
  private SolidifyTime() {
    throw new IllegalStateException(SolidifyConstants.TOOL_CLASS);
  }

  public static void waitOneSecond() {
    waitInSeconds(1);
  }

  public static void waitInMilliSeconds(int delay) {
    try {
      TimeUnit.MILLISECONDS.sleep(delay);
    } catch (InterruptedException e) {
      // Some useful details
      // http://www.yegor256.com/2015/10/20/interrupted-exception.html
      log.error("Interrupted exception", e);
      Thread.currentThread().interrupt();
      throw new RuntimeException(e);
    }
  }

  public static void waitInSeconds(int delay) {
    waitInMilliSeconds(1000 * delay);
  }

}
