package ch.unige.solidify.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class XMLError implements ErrorHandler {

  private static final Logger log = LoggerFactory.getLogger(XMLTool.class);

  private boolean x7;
  private boolean msg;

  public XMLError() {
    msg = false;
    x7 = true;
  }

  public XMLError(boolean m, boolean e) {
    msg = m;
    x7 = e;
  }

  public void warning(SAXParseException e) throws SAXException {
    if (msg)
      log.warn(e.getMessage());
    if (x7)
      throw e;
  }

  public void error(SAXParseException e) throws SAXException {
    if (msg)
      log.error(e.getMessage());
    if (x7)
      throw e;
  }

  public void fatalError(SAXParseException e) throws SAXException {
    if (msg)
      log.error(e.getMessage());
    if (x7)
      throw e;
  }
}