package ch.unige.solidify.util;

import java.util.HashMap;
import java.util.Map;

import com.sun.xml.bind.marshaller.NamespacePrefixMapper;

public class XmlNamespacePrefixMapper extends NamespacePrefixMapper {

  private Map<String, String> namespaces = new HashMap<>();

  public XmlNamespacePrefixMapper() {
    namespaces.put("http://www.w3.org/2001/XMLSchema-instance", "xsi");
    namespaces.put("http://www.w3.org/1999/xhtml", "xhtml");
    namespaces.put("http://www.w3.org/1999/xlink", "xlink");
  }

  @Override
  public String getPreferredPrefix(String namespaceUri, String suggestion, boolean requirePrefix) {
    return namespaces.getOrDefault(namespaceUri, suggestion);
  }

  protected void addSchema(String nameSpace, String nameSpacePrefix) {
    namespaces.put(nameSpace, nameSpacePrefix);
  }

}
